CloneClass(HUDManager)

local add_name_label = HUDManager._add_name_label
function HUDManager:_add_name_label(data)
	add_name_label(self, data)
	self:shortenNames()
end

HUDManager.shortenNames = HUDManager.shortenNames or function(self)
	for i, data in ipairs(self._hud.name_labels) do
		local peer_id = managers.network:session():peer(data.peer_id)
		if peer_id then 
			data.text:set_text(string.sub(peer_id:name(), 1, ShorterNames.options.max or 8))
			self:align_teammate_name_label(data.panel, data.interact)
		end
	end
end

local align_teammate_name = HUDManager.align_teammate_name_label
function HUDManager:align_teammate_name_label(panel, interact)
	for i, data in ipairs(self._hud.name_labels) do
		local peer_id = managers.network:session():peer(data.peer_id)
		if peer_id then 
			data.text:set_text(string.sub(peer_id:name(), 1, ShorterNames.options.max or 8))
		end
	end
	return align_teammate_name(self, panel, interact)
end